/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        31.12.2007
 Description:    Analogeingnge Abfragen
 
 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/
#include "analog.h"
#include "zabex.h"

volatile unsigned char channel = 0;

//------------------------------------------------------------------------------
//
void ADC_Init(void)
{ 
	ADMUX = (1<<REFS0) | (1<<ADLAR); //Left Adjust (wir nutzen nur 8 Bit)
	//Free Running Mode, Division Factor 128, Interrupt on
	ADCSRA=(1<<ADEN)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1)|(1<<ADPS0)|(1<<ADIE);
  	#if defined (__AVR_ATmega644__) || defined (__AVR_ATmega644P__)
    	ADCSRB=0;
	#endif 

}

//------------------------------------------------------------------------------
//
ISR (ADC_vect)
{
#define GAS_HIGH gas_h
#define GAS_LOW  gas_l

#define WASSER_HIGH wasser_h
#define WASSER_LOW  wasser_l

#define STROM_HIGH strom_h
#define STROM_LOW  strom_l

static unsigned char Gaspegel=0;    //0 oder 1
static unsigned char Wasserpegel=0;
static unsigned char Strompegel=0;
unsigned char x;

  ANALOG_OFF; //ADC OFF
  x = ADCH;
  adc_array[channel]=x;
  switch (channel){
    case 0: //Gas
      if (!Gaspegel && (x > GAS_HIGH)){
        Gaspegel = 1;
        jetzt.Zaehlerstand_Gas++;
        verbrauch[viertelstunde].Gas++;
      }else
      if (Gaspegel && (x < GAS_LOW)){
        Gaspegel = 0;
      }
      if ( x > pegelMaxGas) pegelMaxGas = x;
      if ( x < pegelMinGas) pegelMinGas = x;
      channel=1;
      PORTC=Gaspegel;
      break;

    case 1: //Wasser
      if (!Wasserpegel && (x > WASSER_HIGH)){
        Wasserpegel = 1;
        jetzt.Zaehlerstand_Wasser++;
        verbrauch[viertelstunde].Wasser++;
      }else
      if (Wasserpegel && (x < WASSER_LOW)){
        Wasserpegel = 0;
      }
      if ( x > pegelMaxWasser) pegelMaxWasser = x;
      if ( x < pegelMinWasser) pegelMinWasser = x;
      channel=2;
      break;

    case 2: //Strom
      if (!Strompegel && (x > STROM_HIGH)){
        Strompegel = 1;
        strom_markierung=1; //Triggert bernahme der Umdrehungsdauer. Auswertung in Timer.c
        jetzt.Zaehlerstand_Strom++;
        verbrauch[viertelstunde].Strom++;
      }else
      if (Strompegel && (x < STROM_LOW)){
        Strompegel = 0;
      }
      if ( x > pegelMaxStrom) pegelMaxStrom = x;
      if ( x < pegelMinStrom) pegelMinStrom = x;
      channel=0;
      break;
      
    default: channel=0; break;  
  }
  //usart_write("Kanal(%i)=%i\n\r",(channel-1),var_array[(channel-1)]);
  ADMUX =(1<<REFS0) | (1<<ADLAR) | channel;
  //ANALOG_ON passiert in Timer.c
}


