/*----------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Webserver Applikation

 Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der 
 GNU General Public License, wie von der Free Software Foundation verffentlicht, 
 weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder 
 (nach Ihrer Option) jeder spteren Version. 

 Die Verffentlichung dieses Programms erfolgt in der Hoffnung, 
 da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, 
 sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT 
 FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 

 Sie sollten eine Kopie der GNU General Public License zusammen mit diesem 
 Programm erhalten haben. 
 Falls nicht, schreiben Sie an die Free Software Foundation, 
 Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
------------------------------------------------------------------------------*/

#if USE_IOCTRL

#include "ctrlio.h"
//#include "lcd.h"



//Hier wird das codierte Passwort aus config.h gespeichert.
unsigned char ctrl_auth_passwort[20];

unsigned char post_in[5] = {'O','U','T','='};
unsigned char post_ready[5] = {'S','U','B','='};
unsigned char PORT_tmp = 0;

//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
//Initialisierung des I/O Servers
void ctrliod_init (void)
{
	//Serverport und Anwendung eintragen
	add_tcp_app (CTRLIO_PORT, (void(*)(unsigned char))ctrlio);
}
   
//----------------------------------------------------------------------------
//Portzugriff-Server
void ctrlio (unsigned char index)
{
    //Verbindung wurde abgebaut!
    if (tcp_entry[index].status & FIN_FLAG)
    {
        return;
    }
    
    
    
	if (tcp_entry[index].app_status == 0 || tcp_entry[index].app_status == 1)
	{
		tcp_entry[index].app_status = 1; 
		memcpy_P(&eth_buffer[TCP_DATA_START],PSTR("CTRLIO:\r\n"),22);
		create_new_tcp_packet(22,index);
		usart_status.usart_disable = 1;
		telnetd_status.ack_wait = 0;
		tcp_entry[index].time = TCP_TIME_OFF;
		return;
	}	
    
    
  	if ((tcp_entry[index].app_status > 1) && (tcp_entry[index].status&PSH_FLAG))
	{
		tcp_entry[index].app_status = 2;	
        if ((TCP_DATA_END_VAR - TCP_DATA_START_VAR) > 3){
            unsigned char command;
            unsigned char port;
            unsigned char port;
            unsigned char H;
            unsigned char L;
            unsigned char data;
            command = eth_buffer[a++];
            port = eth_buffer[a++];
            H = (eth_buffer[a++] & 0x0f)<<4;
            L = eth_buffer[a++] & 0x0f;
            data = H|L;
            
            /*Kommandos:
            Set Bits on Port   S<Port><H><L>  H: Bit 0..3 gehen OR auf Portbit 4..7 L: Bit 0..3 gehen auf Portbit 0..3
              Beispiel: SA04  setzt Port A, Bit 2  (PA2)
            
            Clear Bits on Port   C<Port><H><L>  H: Bit 0..3 gehen AND NEG auf Portbit 4..7 L: Bit 0..3 gehen auf Portbit 0..3
              Beispiel: CB12  lscht Bit 1 und 4 von Port B
            
            DataDircetion von Port: D<Port><H><L>  H: Bit 0..3 gehen auf PortDirbit 4..7 L: Bit 0..3 gehen auf PortDirbit 0..3
              Beispiel: DC??  setzt PortD komplett auf OUT
            
            
            */
            
            
            switch(port){
               case 'A':  
                 switch(command){
                    case 'S': 
                      PORTA |= data;
                      break;
                    case 'C': 
                      PORTA &=~ data;
                      break;
                    case 'D': 
                      DDRA = data;
                      break;
                 }
                 break;

                 case 'C':  
                 switch(command){
                    case 'S': 
                      PORTC |= data;
                      break;
                    case 'C': 
                      PORTC &=~ data;
                      break;
                    case 'D': 
                      DDRC = data;
                      break;
                 }
                 break;
               case 'D':  
                 switch(command){
                    case 'S': 
                      PORTD |= data;
                      break;
                    case 'C': 
                      PORTD &=~ data;
                      break;
                    case 'D': 
                      DDRD = data;
                      break;
                 }
                 break;
                                 
            }
		}	
		tcp_entry[index].status =  ACK_FLAG;
		create_new_tcp_packet(0,index);
		return;
	}

    

	//Der Header wurde gesendet und mit ACK besttigt (tcp_entry[index].app_status+1)
	//war das Packet fertig, oder mssen weitere Daten gesendet werden, oder Retransmission?
	if (tcp_entry[index].app_status > 2 && tcp_entry[index].app_status < 0xFFFE)
	{
		ctrlio_data_send (index);
		return;
	}
	
	//Verbindung kann geschlossen werden! Alle Daten wurden gesendet TCP Port kann
	//geschlossen werden (tcp_entry[index].app_status >= 0xFFFE)!!
	if (tcp_entry[index].app_status >= 0xFFFE)
	{
		tcp_entry[index].app_status = 0xFFFE;
		tcp_Port_close(index);
		return;
	}
	return;
    
    
    
	
	//Ack erhalten vom gesendeten Packet
	if ((tcp_entry[index].app_status > 1)&&(tcp_entry[index].status&ACK_FLAG)&&(ctrlio_status.ack_wait))
	{
		tcp_entry[index].time = TCP_TIME_OFF;
		rx_buffer_pointer_out = retransmission_pointer;
		ctrlio_status.ack_wait = 0;
		return;
	}
	
	//Time out kein ack angekommen
	if (tcp_entry[index].status == 0) 
	{
		//Daten nochmal senden
		ctrlio_status.ack_wait = 0;
		ctrlio_data_send ();
		return;
	}
	
	return;
    
    
    
    
    
}


//----------------------------------------------------------------------------
//Daten Packete an Client schicken
void ctrlio_data_send (unsigned char index)
{	
	unsigned int a;
	unsigned char hh;
	unsigned char mm;
	unsigned char ss;
    /* Antwort:
      Startzeichen (*)
      Port A H/L
      Port C H/L
      Port D H/L
      ADC0 H/L
       :
      ADC7 H/L
      Zeit :HH
            MM
           SS
      Cr/Lf
    */
    
    a=TCP_DATA_START;
    eth_buffer[a++]='*';
    eth_buffer[a++]=((PINA & 0xf0)>>4)|0x30;
    eth_buffer[a++]=(PINA & 0x0f)|0x30;
    
    eth_buffer[a++]=((PINC & 0xf0)>>4)|0x30;
    eth_buffer[a++]=(PINC & 0x0f)|0x30;
    
    eth_buffer[a++]=((PIND & 0xf0)>>4)|0x30;
    eth_buffer[a++]=(PIND & 0x0f)|0x30;
    
    for (i=0; i<MAX_VAR_ARRAY; i++{
      eth_buffer[a++]=((var_array[i] & 0xf0)>>4)|0x30;
      eth_buffer[a++]=(var_array[i] & 0x0f)|0x30;
    }

    hh = ((time/3600)+b)%24;
    mm = (time/60)%60;
    ss = time %60;
    eth_buffer[a++]=hh|64;
    eth_buffer[a++]=mm|64;
    eth_buffer[a++]=ss|64;
    

    eth_buffer[a++]='\r';
    eth_buffer[a++]='\n';
   
    //Erzeugtes Packet kann nun gesendet werden!
	tcp_entry[index].status =  ACK_FLAG | PSH_FLAG;
	create_new_tcp_packet(a-TCP_DATA_START,index);
	return;	
}

#endif
